*
      SUBROUTINE PAR_TRSV( NAME, N, NPROCS, MMIN, NB )
*
*    NB,    NPROW,NPCOL
*       PDDTSV, PDPTSV
*
*  
      INTEGER            N, NPROCS, MMIN, NB
      CHARACTER*(*)      NAME
*
*   -  
      INTEGER           NPR
      PARAMETER         ( NPR = 6 )
*
*  
      INTEGER            CTXT, I, IAM, IPA, IPB, IPW, IPWOR,
     $                   IPD, IPDL, IPDU, IPE, 
     $                   NP, NQ, NQRHS, NRHS, NB0, WORKSIZ,
     $                   LWORK, NPROW, NPCOL, NPROCS1
*
*  
*
*  
*
      NPROW = 1
      NPCOL = NPROCS
*
      IF( NPROCS .LT. N ) GO TO 9
      WRITE(NPR, FMT = *)' NPROCS .GE. N ! (  NPROCS !! )'
      GO TO 10
    9 NB0 = INT(REAL( N/NPROCS ))
      IF( NB .NE. 1 ) GO TO 8
      WRITE(NPR, FMT = *)' NB = 1 !  NB !!'
      GO TO 10
    8 IF( NB .EQ. 0 ) NB = NB0
*
      IF( NB .GE. 2 ) GO TO 7
      WRITE(NPR, FMT = *)' NB .LT. 2 !  NPROCS !!'
      GO TO 10
*
    7 IF( (N - NB*NPROCS) .EQ. 0 ) GO TO 5
      NPROCS1 = NPROCS - 1
      NB1 = INT(REAL( N/NPROCS1 ))
      IF( (N - NB1*NPROCS1) .NE. 0 ) GO TO 11
        NB = NB1
        NPROCS = NPROCS1
        NPCOL = NPROCS
        GO TO 5
   11   NB = NB1
        GO TO 5
*
*      IA=JA=IB=JB= 1
    5 NRHS = 1
*      NQRHS = 1
*
* LOCr
      NP = 1
* LOCc
      NQ = NB
*      NQRHS = NB
*
*    ( MMIN )
*
      IPDL = 0
      IPD = 0
      IPDU = 0
      IPE = 0
*
*    ()   B
      IPB = 1
*
      IF( NAME .NE. 'PDDTSV' ) GOTO 1
*
*   ,    PDDTSV
*
      LWORK = (12*NPCOL + 3*NB) +
     $        MAX(10*NPCOL + 4*NRHS, 8*NPCOL)
*
* *NQRHS
*       
*
      IPDL = IPB + NB*NRHS
      IPD = IPDL + NB
      IPDU = IPD + NB
*
      IPWOR = IPDU + NB
      GO TO 3
*
    1 IF( NAME .NE. 'PDPTSV' ) GOTO 10
*
*   ,    PDPTSV
*
      LWORK = (12*NPCOL + 3*NB) +
     $        MAX((10 + 2*MIN(100,NRHS))*NPCOL + 4*NRHS, 8*NPCOL)
*
*      
*  
*
      IPD = IPB + NB*NRHS
      IPE = IPD + NB
      IPWOR = IPE + NB
***
    3 IPW = IPWOR + LWORK
*
*     PDLAPRNT  .
*
      WORKSIZ = MAX( NB, NP )
*
*        
      MMIN = IPW + WORKSIZ
*
*      
*
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NPROCS
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL, MMIN
         WRITE( NPR, FMT = 9993 )NB
         WRITE( NPR, FMT = * )'   IPB,  IPWOR,  IPW,  MMIN' 
         WRITE( NPR, FMT = 9994 )IPB, IPWOR,  IPW, MMIN
         WRITE( NPR, FMT = * )'   IPDL,  IPD,    IPDU,  IPE'
         WRITE( NPR, FMT = 9994 )IPDL, IPD, IPDU,  IPE
         WRITE( NPR, FMT = 9991 )LWORK
*
 9991 FORMAT( /'LWORK =' I5 //)
 9994 FORMAT( / 5I7 //)
*
   10 CONTINUE
*
 9992 FORMAT( / '      A X = B',
     $      '    ', A7/ )
 9998 FORMAT( /'     A ',I5,' *',I5,',',
     $       '    ',I3 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I2, ' *', I2, ';' /
     $      '      '/
     $      '    ',
     $      I5,'  '/)
 9993 FORMAT( /'     ( )',
     $       ' NB = ',I3 // '     '/)
      RETURN
      END
